您的位置:首页 > 其它

Codeforces 698A: Vacations(贪心)

2016-07-22 23:40 369 查看
A. Vacations

time limit per test
1 second

memory limit per test
256 megabytes

input
standard input

output
standard output

Vasya has n days of vacations! So he decided to improve his IT skills and do sport. Vasya knows the following information about each
of this n days: whether that gym opened and whether a contest was carried out in the Internet on that day. For the i-th
day there are four options:

on this day the gym is closed and the contest is not carried out;

on this day the gym is closed and the contest is carried out;

on this day the gym is open and the contest is not carried out;

on this day the gym is open and the contest is carried out.

On each of days Vasya can either have a rest or write the contest (if it is carried out on this day), or do sport (if the gym is open on this day).

Find the minimum number of days on which Vasya will have a rest (it means, he will not do sport and write the contest at the same time). The only limitation that Vasya has — he does not want to do the
same activity on two consecutive days: it means, he will not do sport on two consecutive days, and write the contest on two consecutive days.

Input

The first line contains a positive integer n (1 ≤ n ≤ 100)
— the number of days of Vasya's vacations.

The second line contains the sequence of integers a1, a2, ..., an (0 ≤ ai ≤ 3)
separated by space, where:

ai equals
0, if on the i-th day of vacations the gym is closed and the contest is not carried out;

ai equals
1, if on the i-th day of vacations the gym is closed, but the contest is carried out;

ai equals
2, if on the i-th day of vacations the gym is open and the contest is not carried out;

ai equals
3, if on the i-th day of vacations the gym is open and the contest is carried out.

Output

Print the minimum possible number of days on which Vasya will have a rest. Remember that Vasya refuses:

to do sport on any two consecutive days,

to write the contest on any two consecutive days.

Examples

input
4
1 3 2 0


output
2


input
7
1 3 3 2 1 2 3


output
0


input
22 2


output
1


Note

In the first test Vasya can write the contest on the day number 1 and do sport on the day number 3. Thus, he will have a rest for only 2 days.

In the second test Vasya should write contests on days number 1, 3, 5 and 7, in other days do sport. Thus, he will not have a rest for a single day.

In the third test Vasya can do sport either on a day number 1 or number 2. He can not do sport in two days, because it will be contrary to the his limitation. Thus, he will have a rest for only one day.

题目大意:

一个人放假了,给出他放假的天数n,接下来一个数字序列有n个数字,每个数字对应每天的活动,0代表休息,1代表去打比赛,2代表去健身,3代表要么比赛要么健身,问如何安排使得这个人休息天数的最少,输出天数。但是有个规定,就是比赛不能连续两天比赛,健身不能连续两天健身。

解题思路:

从前往后扫,如果扫到3的话,尽量进行活动,即将3变成与前面一天不同的活动;还需注意3开头的,分情况吧,要么变1,要么变2,比较下最终哪个大,输出。

注意数据1 1 1 1,输出的是2,如果连着两天是1,则将第二个1变成0,因为这点wa了多次。

看代码:

#include <stdio.h>
int jisuan(int s[],int n)
{
int cnt=0;
int last=s[0];
if(s[0]==0)
{
cnt++;
}
for(int i=1;i<n;i++)
{
if(s[i]==3)
{
if(last==1)
{
s[i]=2;
last=s[i];
continue;
}
if(last==2)
{
s[i]=1;
last=s[i];
continue;
}
if(last==0)
{
continue;
}
}
if(s[i]==2)
{
if(last==2)
{
cnt++;
last=0;//注意!!!
}
else
{
last=s[i];
}
continue;
}
if(s[i]==1)
{
if(last==1)
{
cnt++;
last=0;//注意。!!!
}
else
{
last=s[i];
}
continue;
}
if(s[i]==0)
{
cnt++;
last=0;
}
}
return cnt;
}
int main()
{
int n;
int a[110];
int b[110];
scanf("%d",&n);
for(int i=0;i<n;i++)
{
scanf("%d",&a[i]);
b[i]=a[i];
}
if(a[0]==3)
{
a[0]=1;
b[0]=2;
int ans1=jisuan(a,n);
int ans2=jisuan(b,n);
if(ans1<ans2)
{
printf("%d\n",ans1);
}
else
{
printf("%d\n",ans2);
}
}
else
{
int ans=jisuan(a,n);
printf("%d\n",ans);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  贪心